#!/bin/sh

# 1.1.3+ compatibility wrapper [stub generator]
# allows to run scripts written for the old script interface.
# Creates stub files that load the compatibility layer, and then the original file
# (C) False.Genesis

# Before running this, copy the "scripts" folder to "scripts2".
# AND MAKE A BACKUP OF THE MOD !!

modname="rpg_PrequelCampaign"

if [ ! -e "scripts2" ]; then
    # Better be safe.
    cp -r scripts scripts2
fi

for f in scripts/*.lua; do
    s=`basename $f`
    echo "Creating stub: $f"
    cat > $f <<EOT
if AQUARIA_VERSION then
    dofile("_loader.lua")
    dofileRaw("scripts2/$s")
else
    dofile(appendUserDataPath("_mods/$modname/scripts2/$s"))
end
EOT
done
