
-- 1.1.3+ compatibility wrapper [optional fixup code]
-- allows to run scripts written for the old script interface.
-- (C) False.Genesis

----------------------------------------------------------------
-- special functions for sacrifice mod to silence warnings
-- (because i am too lazy to fix all scripts by hand! -- FG)
----------------------------------------------------------------

-- not defined but expected in one script
FLAG_COLLECTIBLE_TURTLESHELL = 533

-- this is referenced in node_vendorm* but never set anywhere
-- this defaulted to setStringFlag("", xyz) (verified in unpacked save files).
-- Need to set to empty string (yes, that works!) to preserve compatibility with older saved games.
PURCHASE = ""



-- quite a few dialog related nodes use this but never declare it first.
local function init_node(me)
    mbDown = false
end

-- dispatch to specialized init function
local function initByName(sc, me)

    if sc:startsWith("node_") then
        return init_node(me)
    --elseif ...
    -- ...
    end
    
    
end


-- fixup code
local function initHook(file, me)
    local a = file:explode("/", true)
    local sc = a[#a]
    return initByName(sc, me)
end

rawset(_G, "initHook", initHook)

rawset(_G, "__HACKFIXES_LOADED", true)
