
-- 1.1.3+ compatibility wrapper [bootstrap code]
-- allows to run scripts written for the old script interface.
-- (C) False.Genesis

--[[ To use this in other mods, do the following:
    * copy "scripts" directory to "scripts2"
    * run _gen.sh in any shell (on windows, use msys or cygwin shell)
    * drop _loader.lua (this file), _compat.lua into the root dir of your mod.
    * Adjust _hackfixes.lua and copy it as well, if necessary. Otherwise, set FG_NEED_HACKFIXES below to false.
    * Hope it works.
]]

--== CONFIG PART ==--
FG_LOADER_MOD_NAME = "rpg_PrequelCampaign" -- set this to the folder name of the mod
FG_ENABLE_DEV_MODE = true               -- otherwise it's impossible to track down errors (only for debugging!)
FG_NEED_HACKFIXES = true                -- enable this to load _hackfixes.lua as well


if not v then
    debugLog("OOPS: v not there, saving the day")
    v = {}
end

if not rawget(_G, "__COMPAT_LOADED") then
    dofile("_compat.lua")
end

if FG_NEED_HACKFIXES and (FG_ENABLE_DEV_MODE or not rawget(_G, "__HACKFIXES_LOADED")) then
    dofile("_hackfixes.lua")
end

