dofile("scripts/entities/entityinclude.lua")

n = 0
seen = false


function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL)
	entity_initSkeletal(me, "DeepWhale")
	
	--original = 1.5
	entity_scale(me, 1, 1)
	entity_setEntityLayer(me, -3)
	
	entity_setCullRadius(me, 3500)

	entity_setState(me, STATE_IDLE)
	
	--loadSound("DeepWhale-Open")
	
	entity_setInternalOffset(me, 0, -50)
	entity_setInternalOffset(me, 0, 50, 4, -1, 1, 1)
end

function postInit(me)
	n = getNaija()
	entity_setTarget(me, n)
end

function update(me, dt)
end

function enterState(me)
	if entity_isState(me, STATE_IDLE) then
		entity_animate(me, "idle", -1)
	end
end

function exitState(me)
end
